#!/bin/bash
###################################
### DQproc 1=iter 2=qv		###
###################################
yisdir=./
bindir=${yisdir}/bin
datdir=${yisdir}/dat

iter=${1}
qv=${2}

grdo=${datdir}/layer4.vc.${qv}.grdo.iter${iter}.H
grdp=${datdir}/layer4.vc.${qv}.grdp.iter${iter}.H
srch=${datdir}/layer4.vc.${qv}.srch.iter${iter}.H
vPre=${datdir}/layer4.vc.bqtv.vPre.H

Smooth <${grdo} rect1=10|Window3d squeeze=n min1=0 n1=501>temp1.H
Math file1=temp1.H file2=${vPre} exp="file1*file2" >${grdp}
${bindir}/myMPI-gradprcs.x grdo=${grdp}  rectx_grd=10 recty_grd=1 rectz_grd=10 nsmt_grd=3 smtgrd=y smttyp="triflt" grdmsk=n gscale=n
${bindir}/myMPI-srchdrct.x srch=${srch} grdo=${grdp} method="sdstep" rstart=n
Rm temp1.H

