module base_hlxtyp_mod
  implicit none

  type helix
       real   , dimension(:), pointer :: flt
       integer, dimension(:), pointer :: lag
       logical, dimension(:), pointer :: mis
  end type

  type nhelix
       logical    , dimension(:), pointer :: mis
       integer    , dimension(:), pointer :: pch
       type(helix), dimension(:), pointer :: hlx
  end type

contains
  subroutine allocatehelix(aa, nh) 
    type(helix) :: aa
    integer     :: nh
    allocate(aa%flt(nh), aa%lag(nh))
    nullify(aa%mis)
    aa%flt = 0.
    aa%lag = 0
    return
  end subroutine 

  subroutine deallocatehelix(aa)
    type(helix) :: aa
    deallocate(aa%flt, aa%lag)
    if (associated(aa%mis)) deallocate(aa%mis)
    return
  end subroutine
end module
