!!-------------------------------------------------------------------------------
!!.. Author: Yaxun Tang, tang@sep.stanford.edu
!!-------------------------------------------------------------------------------
module base_qgrd_mod
  use base_struct_mod
  implicit none

contains

  subroutine base_qgrd_gen3d(qgrid, pgrid, igrid)
    type(q_grid) :: qgrid
    type(pro_grid) :: pgrid
    type(img_grid) :: igrid

    !!.. calculate the index of propagation grid on the entire q grid
    qgrid%index_proq_xmin = 1.5 + (pgrid%ax%o - qgrid%ax%o)/qgrid%ax%d
    qgrid%index_proq_ymin = 1.5 + (pgrid%ay%o - qgrid%ay%o)/qgrid%ay%d
    qgrid%index_proq_zmin = 1.5 + (pgrid%az%o - qgrid%az%o)/qgrid%az%d
    qgrid%index_proq_xmax = qgrid%index_proq_xmin + pgrid%ax%n - 1
    qgrid%index_proq_ymax = qgrid%index_proq_ymin + pgrid%ay%n - 1
    qgrid%index_proq_zmax = qgrid%index_proq_zmin + pgrid%az%n - 1

    qgrid%index_imgq_xmin = 1.5 + (igrid%ax%o-qgrid%ax%o)/qgrid%ax%d
    qgrid%index_imgq_ymin = 1.5 + (igrid%ay%o-qgrid%ay%o)/qgrid%ay%d
    qgrid%index_imgq_zmin = 1.5 + (igrid%az%o-qgrid%az%o)/qgrid%az%d
    qgrid%index_imgq_xmax = 1.5 + (igrid%ax%o+(igrid%ax%n-1)*igrid%ax%d-qgrid%ax%o)/qgrid%ax%d
    qgrid%index_imgq_ymax = 1.5 + (igrid%ay%o+(igrid%ay%n-1)*igrid%ay%d-qgrid%ay%o)/qgrid%ay%d
    qgrid%index_imgq_zmax = 1.5 + (igrid%az%o+(igrid%az%n-1)*igrid%az%d-qgrid%az%o)/qgrid%az%d

    if (qgrid%index_proq_xmin < 1 .or. qgrid%index_proq_xmax > qgrid%ax%n) then
       write(0,*)"error: qgrid%index_proq_xmin or xmax"
       stop
    end if
    if (qgrid%index_proq_ymin < 1 .or. qgrid%index_proq_ymax > qgrid%ay%n) then
       write(0,*)"error: qgrid%index_proq_ymin or ymax"
       stop
    end if
    if (qgrid%index_proq_zmin < 1 .or. qgrid%index_proq_zmax > qgrid%az%n) then
       write(0,*)"error: qgrid%index_proq_zmin or zmax"
       stop
    end if

    return
  end subroutine

end module
