!!.. read nzs depth step qocity or slowness
module bwi_qref_mod
  implicit none
  integer, private :: nqrf
contains

!=====================================================================
!
  integer function bwi_qref_init(nqrf_in) result(stat)
    integer :: nqrf_in
    integer :: nx_in
    integer :: ny_in

    nqrf  = nqrf_in

    stat  = 0
  end function
!======================================================================
  integer function bwi_qref_clos() result(stat)
    nqrf  = 0
    stat  = 0
  end function
!======================================================================
!.. select the reference qocity for the current depth step
!.. Lloyd's method will be used
!----------------------------------------------------------------------
  integer function bwi_qref_oper(qmod_slice, qref_slice) result(stat)
    real, dimension(:,:) :: qmod_slice
    real, dimension(:)   :: qref_slice

    integer              :: iref, nqrf_sec, ix, iy, ic
    real                 :: qmin_pri, qmax_pri
    real                 :: qmin_sec, qmax_sec, dq

    stat = 1
    if(nqrf > size(qref_slice)) call seperr("ERROR: nref larger than the size of qref_slice(:)")
    qref_slice=0.0

    if (nqrf==1) then
       qref_slice(1) = sum(qmod_slice)/size(qmod_slice)

    else if (nqrf==2) then
       qref_slice(1) = minval(qmod_slice)
       qref_slice(2) = maxval(qmod_slice)

    else if (nqrf==3) then
       qref_slice(1) = minval(qmod_slice)
       qref_slice(2) = sum(qmod_slice)/size(qmod_slice)
       qref_slice(3) = maxval(qmod_slice)

    else
       qmin_pri = minval(qmod_slice)
       qmax_pri = maxval(qmod_slice)

       qmin_sec = minval(qmod_slice, MASK=qmod_slice-qmin_pri>+50.)
       qmax_sec = maxval(qmod_slice, MASK=qmod_slice-qmax_pri<-50.)

       if (abs(qmin_sec)<qmin_pri .or. abs(qmin_sec)>qmax_pri) qmin_sec = qmin_pri
       if (abs(qmax_sec)<qmin_pri .or. abs(qmax_sec)>qmax_pri) qmax_sec = qmax_pri

       qref_slice(1)    = qmin_pri
       qref_slice(nqrf) = qmax_pri
       nqrf_sec         = nqrf - 2 

       dq=(qmax_sec-qmin_sec)/(nqrf_sec-1)
       do iref=1, nqrf_sec
          qref_slice(iref+1)=qmin_sec+(iref-1)*dq
       end do
    end if
    stat = 0 
  end function

end module
