!!! Yi Shen Mar 26, 2013
module bwi_qrestom_mod
  use base_struct_mod
  use bwi_fileio_mod
  use bwi_offdso_mod
  use line
  use smallsolver
  use cgstep_mod
  use wei_myfft_mod
  use wei_hamming_mod
  implicit none


contains

  integer function bwi_qrestom_oper(bimg_, hess_, imsk_, igrid, hgrid, fobj, objtyp, nwin, lwin, fmin, fmax, lsniter, neigh, ver, ng, nref, nsmth, slop_neg) result(stat)
    character(len=*) :: bimg_, hess_, imsk_
    type(img_grid)   :: igrid
    type(hes_grid)   :: hgrid
    double precision :: fobj
    character(len=6) :: objtyp

    integer          :: ix, iy, izs, ihx, ihy

    real, dimension(:,:,:,:,:), allocatable :: imgstk       !!! Add imagstk: 5 dimensions include z
    real, dimension(:,:)    , allocatable :: imsk

  integer			:: n1, n2, n3, n4, n5
  real				:: d5
  integer			:: i1, i2, i3, i4, i5, iwin, ig, is3, is5
  real				:: dw,ow
  integer			:: ismth, nsmth
  integer			:: nw
  integer			:: tbeg, tend,tend2
  logical			:: neigh, ver, slop_neg
  integer			:: ng, nref
  integer			:: dwin, nwin, lwin, lsniter, nwin2
  real				:: fmin, fmax
  integer			:: nf, iif, ifmin
  complex, allocatable 		:: ctrace1(:),ctrace2(:),wtrace(:)
  complex, allocatable		:: fft1(:,:,:,:),fft2(:,:,:,:)
  real, allocatable		:: spex(:,:,:,:), spex2(:,:,:,:)
  real, allocatable		:: rati(:,:,:,:)
  real, allocatable		:: ftln(:,:,:,:)
  real, allocatable		:: slop(:,:,:),slopsft(:,:,:), slopsft2(:,:,:), scalsft(:,:,:)
  real, allocatable		:: scal(:,:,:)
  real, allocatable		:: d(:), m(:)
  real, allocatable 		:: dimg(:,:,:,:,:)
  real, allocatable		:: maxspex2(:,:,:)


    allocate(imsk(igrid%ax%n,igrid%ay%n))
    allocate(imgstk(igrid%ahx%n,igrid%ahy%n,igrid%ax%n,igrid%ay%n,igrid%az%n))
    select case (objtyp)

    case ("stk")
	do izs=1, igrid%az%n
           call bwi_fio_imag_updt(imgstk(:,:,:,:,izs), igrid, izs, bimg_, "reed")
	end do
        
!!! set constant value
	n1=igrid%ahx%n
	n2=igrid%ahy%n
	n3=igrid%ax%n
	n4=igrid%ay%n
	n5=igrid%az%n
	d5=igrid%az%d
 	ow=0.
  	nw=n5;
  	dw = 1./(n5*d5)
        if(nwin==1) then
	  dwin=0
        else
	  dwin=(n5-lwin*nwin)/(nwin-1)
        end if
        nwin2=n5/(lwin+dwin)
        nf=(fmax-fmin)/dw+1   !!! pick nf for least square
  !	write(0,*)'dwin,nwin2',dwin+lwin,nwin2


  allocate(ctrace1(n5),ctrace2(n5), wtrace(nw), dimg(n1, n2, n3, n4, n5),fft1(n3, n4, nwin, nw),fft2(n3, n4, nwin2, nw))
  allocate(spex(n3, n4, nwin, nw),spex2(n3, n4, nwin2, nw),rati(n3, n4, nwin, nw), ftln(n3, n4, nwin, nw))
  allocate(slop(n3, n4, nwin),scal(n3, n4, nwin),slopsft(n3,n4,n5),slopsft2(n3,n4,nwin),scalsft(n3,n4,n5))
  allocate(m(2),d(nf))
  allocate(maxspex2(n3, n4, nwin2))
!!!!!!!!!!!!  FFT
!???????????  no hamming window, nz=nw
!!! for Q analysis
  fft1=0.;
  do i2=1, n2
  do i1=1, n1
  do i4=1,n4
    do i3=1,n3
      do iwin=1,nwin

        
	tbeg=(iwin-1)*(lwin+dwin)+1
	tend=tbeg+lwin      

	if(tend .gt. n5 ) then
	  tend=n5
        end if
        ctrace1=0.;
        ctrace1(tbeg:tend)=imgstk(i1, i2 ,i3 , i4, tbeg:tend)
	call FFT1DX(ctrace1, 1)

        fft1(i3, i4, iwin, :) =ctrace1	

      end do

    end do
  end do
  end do 
  end do

!!! for inverse FFT to get dimg
  fft2=0.;

  do i2=1, n2
  do i1=1, n1
  do i4=1,n4
    do i3=1,n3
      do iwin=1,nwin2
      
	tbeg=(iwin-1)*(lwin+dwin)+1
	tend2=tbeg+lwin+dwin 
	if(tend2 .gt. n5 ) then
	  tend2=n5
        end if
	ctrace2=0.
        ctrace2(tbeg:tend2)=imgstk(i1, i2 ,i3 , i4, tbeg:tend2)
	call FFT1DX(ctrace2, 1)
        fft2(i3, i4, iwin, :) =ctrace2	
      end do

    end do
  end do
  end do 
  end do
!!!!!!!!!!!! spectral : group the traces or not
 spex=0.0
  do i4=1,n4
  do i3=1,n3
     do ig=1,ng
	if (i3+ig-1 .gt. n3) then
		exit
	else
    		 spex(i3, i4, :, :)=spex(i3,i4,:,:)+abs(fft1(i3+ig-1, i4, :, :))
	end if
     end do
  end do
  end do

!!!!!!!!!!!! spectral : group the traces or not
 spex2=0.0
  do i4=1,n4
  do i3=1,n3
     do ig=1,ng
	if (i3+ig-1 .gt. n3) then
		exit
	else
    		 spex2(i3, i4, :, :)=spex2(i3,i4,:,:)+abs(fft2(i3+ig-1, i4, :, :))
	end if

     end do
  end do
  end do

!write(0,*) "FFT..."
!!!!!!!!!!!! spectral ratio  (vertical vs horizontal; first vs neighbor )
!?????????? if (spex(i3,i4,iwin,i5) .lt. 1./1000.*rtmax) then rati(i3,i4,iwin,i5)=0.



  rati=0.
  do i4=1, n4
  do i2=1, n2
  do i1=1, n1
  ! vertial window compare
  if (ver) then  
    do i3=1, n3
    do i5=1, nw
      ! reference window compare, by default nref=1
      if (neigh == .false.) then
	if (spex(i3,i4,nref,i5)==0.) then
		rati(i3,i4,:,i5)=0.	
	else
		do iwin=1,nwin
			
			rati(i3, i4, iwin, i5)=log(spex(i3,i4,iwin,i5)/spex(i3,i4,nref,i5))

 		end do
	end if
      ! neighbor window compare
      else
 	rati(i3,i4,1,i5)=1.
	do iwin=2,nwin
	   if (spex(i3,i4,iwin-1,i5)==0.) then
		rati(i3,i4,iwin,i5)=0.	
	   else
		rati(i3,i4,iwin,i5)=log(spex(i3,i4,iwin,i5)/spex(i3,i4,iwin-1,i5))
	   end if
	end do
      end if
    end do
    end do 
  ! horizontal window compare
  else   
    do iwin=1,nwin
    do i5=1, nw
      ! reference window compare, by default nref=1
     if (neigh == .false.) then
	         if (spex(nref, i4, iwin, i5) ==0.) then
		rati(:, i4, iwin, i5)=0.
         else
		do i3=1, n3
			rati(i3, i4, iwin, i5) = log (spex(i3, i4, iwin, i5)/spex(nref, i4, iwin, i5))
		end do
	 end if
      ! neighbor window compare
     else
	rati(1,i4, iwin, i5) =1. 
	do i3=2, n3
	   if (spex(i3-1,i4,iwin,i5)==0.) then
		rati(i3,i4,iwin,i5)=0.	
	   else
		rati(i3,i4,iwin,i5)=log(spex(i3,i4,iwin,i5)/spex(i3-1,i4,iwin,i5))
	   end if
        end do
      end if
     end do
     end do
  end if
  end do
  end do
  end do
!write(0,*) "Spectral ratio"

!!!!!!!!!!!!!!!!!! least square fitting

  d=0.; m=0.;
  slop=0.;scal=0.; ftln=0.


  do i2=1, n2
  do i1=1, n1
  do i4=1, n4
  if (ver) then
    do i3=1, n3
    slop(i3,i4,1)=0.
    scal(i3,i4,1)=0.
    ftln(i3,i4,1,:)=0.
     do iwin=2, nwin
        do iif=1,nf
	  ifmin=(fmin-ow)/dw
  	  d(iif)=rati(i3, i4, iwin, ifmin+iif)

        end do

	call line_init(nf, fmin, dw)
        stat= line_lop( .true., .false., m, d)
	call solver(oper=line_lop, solv=cgstep, x=m,dat=d,niter=lsniter)
	slop(i3,i4,iwin)=m(1)
 	scal(i3,i4,iwin)=m(2)
	do i5=1,nw/2
		ftln(i3,i4,iwin,i5)=scal(i3,i4,iwin)+slop(i3,i4,iwin)*((i5-1)*dw+ow)
	end do
	!write(0,*) "scal, slop", scal(i3,i4,iwin),slop(i3,i4,iwin)
    end do
    end do
  else
    do iwin=1, nwin
    slop(nref,i4,iwin)=0.
    scal(nref,i4,iwin)=0.
    ftln(nref,i4,iwin,:)=0.
     do i3=1, n3
        do iif=1,nf
	  ifmin=(fmin-ow)/dw
  	  d(iif)=rati(i3, i4, iwin, ifmin+iif)

        end do
	call line_init(nf, fmin, dw)
        stat = line_lop( .true., .false., m, d)
	call solver(oper=line_lop, solv=cgstep, x=m,dat=d,niter=lsniter)
	slop(i3,i4,iwin)=m(1)
 	scal(i3,i4,iwin)=m(2)

	do i5=1,nw/2
		ftln(i3,i4,iwin,i5)=scal(i3,i4,iwin)+slop(i3,i4,iwin)*((i5-1)*dw+ow)
	end do
	!write(0,*) "scal, slop", scal(i3,i4,iwin),slop(i3,i4,iwin)
    end do
    end do
  end if
  end do 
  end do
  end do

!write(0,*) "least square"

 !!!!!!!!!!!!!!!!!!1 ! image pertubation
	! 1. shift and smooth and eclip=0.0
	slopsft=0.
        fobj=0.
	do i3=ng/2,n3
	do i4=1,n4
!	do iwin=1, nwin
	do i5=lwin/2,n5
		is3=i3-ng/2+1
		is5=(i5-lwin/2)/(lwin+dwin)+1
		do ismth=1,nsmth
			if (is5+ismth-1 .gt. nwin ) then
				exit
			else
				slopsft(i3,i4,i5)=slopsft(i3,i4,i5)+slop(is3,i4,is5+ismth-1)
				scalsft(i3,i4,i5)=scalsft(i3,i4,i5)+scal(is3,i4,is5+ismth-1)
			end if
		!write(0,*) "is3, is5, nwin", is3, is5, nwin
		end do
		if (slopsft(i3, i4, i5) .gt. 0. .and. slop_neg .eq. .true.) then
			slopsft(i3, i4, i5) =0.
			scalsft(i3, i4, i5) =0.
		else
			slopsft(i3,i4,i5)=slopsft(i3,i4,i5)/nsmth
			scalsft(i3,i4,i5)=scalsft(i3,i4,i5)/nsmth
		end if
		fobj=fobj+(slopsft(i3, i4, i5)*slopsft(i3, i4, i5))/n3/n4/n5
	end do
	end do
	end do
!write(0,*) "slope shift"
!write(0,*) " fobj",fobj

  dimg=0.0
  wtrace=0.
  do i2=1, n2
  do i1=1, n1
  do i4=1, n4
     do i3=1, n3
   ! do i3=100,200
    !!! dimg: small windowed local FFT * correction 

    do iwin=1, nwin2
	is5=(iwin-1)*(lwin+dwin)+1
	maxspex2(i3 ,i4, iwin)=sum(spex2(i3, i4,iwin, :))/nw
	wtrace(1)=fft2(i3,i4,iwin,1)/exp(scalsft(i3, i4, is5))/maxspex2(i3, i4, iwin)*(slopsft(i3, i4, is5)*(ow))
       do i5=2,(nw/2)+1

    	    wtrace(i5) = (fft2(i3, i4, iwin, i5))/(maxspex2(i3, i4, iwin))  *(slopsft(i3, i4, is5)*(ow+dw*(i5-1)))
    	    wtrace(nw-i5+2) = (fft2(i3, i4, iwin, nw-i5+2))/(maxspex2(i3, i4, iwin))* (slopsft(i3, i4, is5)*(ow+dw*(i5-1)))
       end do
       call FFT1DX(wtrace, -1)
       dimg(i1, i2, i3, i4, :) = dimg(i1, i2, i3, i4, :)+ real(wtrace(:))
       wtrace = 0.

    end do

    end do
  end do
  end do 
  end do


	do izs=1, igrid%az%n
              call bwi_fio_imag_updt(dimg(:,:,:,:,izs), igrid, izs, bimg_, "rite")
	end do

!               if (igrid%imgmsk) then
!                  call bwi_fio_imsk_updt(imsk, igrid, izs, imsk_, "reed")
!                  do ihy=1, igrid%ahy%n
!                  do ihx=1, igrid%ahx%n
!                     dimg(ihx,ihy,:,:) = dimg(ihx,ihy,:,:)*imsk(:,:)
!                  end do
!                  end do	  
!               end if



  deallocate(ctrace1,ctrace2, wtrace, fft1,fft2,dimg, imgstk)
  deallocate(spex,spex2,rati)
  deallocate(ftln,slop,scal,m,d,slopsft, slopsft2, scalsft)
  deallocate(maxspex2)
	case("sparse")
!!! Envelop:/net/server/opt_local/SEP/seplib/seplib_prog/seis/filter
!!! Read the file from disk to memory
   !do iz=1,nz
	!bwi_fio_rimg_init(igrid, filetag)
	!bwi_fio_rimg(modl, igrid, ogrid, jz, jsx, jsy, filetag, flag)
        !fio(bimage_, temp(:,:,iz), iz, "reed")
  !end do
!!! Calculate the envelop
   !call env(temp) 
!!! Get the spike
    !do iz=1,nz
   	!fio(dimage_, temp(:,:,iz), iz, "rite")
    !end do
!!! Forward modeling and migration
   ! stat = bwi_kerimg_oper(adj, add, F, ftag_%csou_, tmp_crec, ftag_%bvel_,tmp_bq, tmp_bimg, qcomp_clip)   !!!should define tmp_crec,tmp_bq,tmp_bimg
   ! stat = bwi_kerimg_oper(adj, add, F, ftag_%csou_, tmp_crec, ftag_%bvel_, tmp_bq, tmp_timg, qcomp_clip)    !!! should define tmp_timg
!!! Calculate mask 
!!! Calculate A  
!!! Subtract
    end select

    deallocate(imsk)
    stat = 0
  end function

end module
