!!.. read nzs depth step velocity or slowness
module bwi_ref_mod
use sep3d_struct_mod
use lloyd_mod
use sep
  implicit none
  integer, private :: nrf
contains

!=====================================================================
!
  integer function bwi_ref_init(nrf_in, nx_in, ny_in) result(stat)
    integer :: nrf_in
    integer :: nx_in
    integer :: ny_in

    nrf  = nrf_in
    nx   = nx_in
    ny   = ny_in

    stat  = 0
  end function
!======================================================================
  integer function bwi_ref_clos() result(stat)
    nrf   = 0
    stat  = 0
  end function
!======================================================================
!.. select the reference velocity for the current depth step
!.. Lloyd's method will be used
!----------------------------------------------------------------------
  integer function bwi_ref_oper(vmod_slice, qmod_slice, vref_slice, qref_slice, zref, iregion) result(stat)
    real, dimension(:,:) :: vmod_slice
    real, dimension(:)   :: vref_slice
    real, dimension(:,:) :: qmod_slice
    real, dimension(:)   :: qref_slice

    real, allocatable :: attr(:,:),slice(:,:),junk(:,:)
    integer,allocatable :: iregion(:),nstart(:)
    integer :: nref,iref,n(3), zref, ix, iy

   call sep_init(SOURCE)

   call init_lloyd();

   n(1)=2; n(2)=nx; n(3)=ny;
   allocate(iregion(n(2)*n(3)),junk(n(1),n(2)*n(3)),slice(n(2)*n(3),n(1)), attr(nref,n(1)), nstart(n(1)))

   nstart=(/1,3/)
   if(product(nstart) > nref) &
   call seperr("product(nstart) > nref")

   do ix=1,nx
   do iy=1,ny 
      junk(1,ix+(iy-1)*ny)=vmod_slice(ix,iy)
      junk(2,ix+(iy-1)*ny)=qmod_slice(ix,iy)
   end do
   end do
   slice=transpose(junk)
   iref= lloyd_go(slice, attr, nref, iregion,nstart)
     if(iref < nref) then
       attr(iref+1:,:)=-1
     end if
   vref_slice=attr(:,1)
   qref_slice=attr(:,2)
   zref=iref
  end function
end module
