!!---------------------------------------------------------------------------
!! Author: Yaxun Tang, tang@sep.stanford.edu
!!---------------------------------------------------------------------------
!! Add q in ssr_epi and Fxop by Yi Shen (Nov 28, 2011)  --- intepolation not finished
!! finish intepolation Jan 17, 2012 
!!---------------------------------------------------------------------------
!! Add Q compensation by Yi Shen (Apr 5, 2012)
!! 	1)ssr_epi (qcomp, qcomp_clip): define, stat=FXOP
!!	2)Fxop(qcomp, qcomp_clip): define
!!---------------------------------------------------------------------------
module bwi_ssrepi_mod
  implicit none

contains
  !----------------------------------------------------------------------------------------------------------------------
  !.. Multiple reference velocity extrapolation plus interpolation
  !----------------------------------------------------------------------------------------------------------------------
  integer function ssr_epi(adj, Fxop, wfld_slice, vmod_slice, qmod_slice, vref_slice, qref_slice, kx2, ky2, ws, dz, nx, ny, nvrf, nqrf, opsign, &
                           ivwrk2d,iqwrk2d, cwrk3d, plan_2dxF, plan_2dxI, qcomp, qcomp_clip, p1, p2, p3 ,p4) result(stat)  !!! add qmod_slice, qref_slice, nqrf, iqwrk2d, iwrk2d->ivwrk2d
    logical                   :: adj
    complex, dimension(:,:)   :: wfld_slice
    real   , dimension(:,:)   :: vmod_slice
    real   , dimension(:)     :: vref_slice
    real   , dimension(:)     :: kx2, ky2
    real                      :: ws
    real                      :: dz
    integer                   :: nx, ny, nvrf
    integer                   :: opsign
    integer, dimension(:,:)   :: iqwrk2d,ivwrk2d
    complex, dimension(:,:,:) :: cwrk3d
    integer*8                 :: plan_2dxF
    integer*8                 :: plan_2dxI
    real   , dimension(:,:)   :: qmod_slice     !!! add qmod
    real   , dimension(:)     :: qref_slice     !!! add qref
    integer		      :: nqrf           !!! add nqrf
    logical	    	      :: qcomp
    real	    	      :: qcomp_clip
    real		      :: p1, p2, p3, p4
    interface
      integer function Fxop(adj, wfld_slice, vmod_slice, qmod_slice, kx2, ky2, vref, qref, ws, dz, nx, ny, opsign, plan_2dxF, plan_2dxI, qcomp, qcomp_clip, p1, p2, p3 ,p4) result(stat) !!! add qmod and qref
        logical                 :: adj
        complex, dimension(:,:) :: wfld_slice
        real   , dimension(:,:) :: vmod_slice
        real   , dimension(:)   :: kx2, ky2
        real                    :: vref
        real                    :: ws
        real                    :: dz
        integer                 :: nx, ny
        integer                 :: opsign
        integer*8               :: plan_2dxF
        integer*8               :: plan_2dxI
        real   , dimension(:,:) :: qmod_slice   !!! add qmod
        real                    :: qref         !!! add qref
	logical	    	        :: qcomp
        real	    	        :: qcomp_clip
        real		        :: p1, p2, p3, p4
      end function
    end interface

    integer                     :: ix, iy, itr, ivrf, jvrf
    integer 			:: iqrf, jqrf                            !!!add iq
    real                        :: vmin, vmax, dvel, vref, vdif1, vdif2
    real 			:: qmin, qmax, dq, qref, qdif1, qdif2    !!!add q

    if (nvrf == 1) then
       vref = vref_slice(1)
       qref = qref_slice(1)
       stat = FXop(adj, wfld_slice, vmod_slice, qmod_slice, kx2, ky2, vref, qref, ws, dz, nx, ny, opsign, plan_2dxF, plan_2dxI, qcomp, qcomp_clip, p1, p2, p3 ,p4 )

    else
	
       ivwrk2d = 0
       iqwrk2d = 0      !!! iwrk2d -> ivwrk2d, iqwrk2d

!      calculate the velocity map for wavefield interpolation
!      ------------------------------------------------------
       do iy=1, ny
       do ix=1, nx
          jvrf = 1
          do ivrf=1, nvrf-1
             vdif1 = abs(vmod_slice(ix,iy)-vref_slice(ivrf)  )
             vdif2 = abs(vmod_slice(ix,iy)-vref_slice(ivrf+1))
             if (vdif1<vdif2) then
                jvrf = ivrf
                exit
             else
                jvrf = ivrf+1
             end if
          end do
          ivwrk2d(ix,iy) = jvrf
       end do
       end do

!      calculate the velocity map for wavefield interpolation
!      ------------------------------------------------------
       do iy=1, ny
       do ix=1, nx
          jqrf = 1
          do iqrf=1, nqrf-1
             qdif1 = abs(qmod_slice(ix,iy)-qref_slice(iqrf)  )
             qdif2 = abs(qmod_slice(ix,iy)-qref_slice(iqrf+1))
             if (qdif1<qdif2) then
                jqrf = iqrf
                exit
             else
                jqrf = iqrf+1
             end if
          end do
          iqwrk2d(ix,iy) = jqrf
       end do
       end do

       if (adj) then

!         *********************
!         ADJOINT INTERPOLATION
!         *********************

!         copy current interpolated wavefield into a backup array
!         -------------------------------------------------------
          cwrk3d(:,:,1) = wfld_slice
!         zero out buffer
!         ---------------
          cwrk3d(:,:,2) = 0.
!         loop over reference velocities
!         ------------------------------
          do ivrf=1, nvrf
	  do iqrf=1, nqrf
             vref = vref_slice(ivrf)
	     qref = qref_slice(iqrf)
!            adjoint of nearest-neighbour interpolation
!            ------------------------------------------ 
             wfld_slice = 0.
             where (ivwrk2d == ivrf .and. iqwrk2d == iqrf)
                   wfld_slice = cwrk3d(:,:,1)
             end where
!            adjoint propagation
!            -------------------
             stat = FXop(adj, wfld_slice, vmod_slice, qmod_slice, kx2, ky2, vref, qref,  ws, dz, nx, ny, opsign, plan_2dxF, plan_2dxI, qcomp, qcomp_clip , p1, p2, p3 ,p4 )
!            adjoint of copying wavefields
!            -----------------------------
             cwrk3d(:,:,2) = cwrk3d(:,:,2) + wfld_slice
          end do
	  end do
!         copy the wavefield back
!         ----------------------- 
          wfld_slice = cwrk3d(:,:,2)

       else

!         *********************
!         FORWARD INTERPOLATION
!         *********************

!         copy current wavefield into a backup array
!         ------------------------------------------
          cwrk3d(:,:,1) = wfld_slice
!         zero out buffers
!         ----------------
          cwrk3d(:,:,2) = 0.
          wfld_slice    = 0.
!         loop over reference velocities
!         ------------------------------
	  do iqrf=1, nqrf
          do ivrf=1, nvrf
!            propagate wavefields according to different reference velocities
!            ----------------------------------------------------------------
	     qref = qref_slice(iqrf)
             vref = vref_slice(ivrf)
             wfld_slice = cwrk3d(:,:,1)
             stat = FXop(adj, wfld_slice, vmod_slice, qmod_slice, kx2, ky2, vref, qref, ws, dz, nx, ny, opsign, plan_2dxF, plan_2dxI, qcomp, qcomp_clip, p1, p2, p3 ,p4 )
!            nearest-neighbor interpolation
!            ------------------------------ 
             where (ivwrk2d == ivrf .and. iqwrk2d == iqrf)
                   cwrk3d(:,:,2) = wfld_slice
             end where
          end do
	  end do
!         copy the interpolated wavefield back to current wavefield
!         ---------------------------------------------------------
          wfld_slice = cwrk3d(:,:,2)

       end if 
   end if
   stat = 0
  end function


end module
