!!! Image pertuatbation due to perturbed Q from post stack image - Yi Shen, Feb 26, 2013
!!! input.H: input[hx, hy, mx, my, mz]
!!! dimg.x <input.H nwin=[] lwin=[] spex=spex.H rati=rati.H ftln=ftln.H slop=slop.H scal=scal.H fobj=fobj.H neigh=n ver=y ngroup=1 nref=1 nsmth=1 alpha=1. dimgamp=0 slop_neg=1>output.H
! ! spex=spex[mx, my, win, freq].H 
! ! rati=rati[mx, my, win, freq].H 
! ! ftln=ftln[mx, my, win, freq].H 
! ! slop=slop[mx, my, win, freq].H 
! ! scal=scal[mx, my, win, freq].H 
! ! fobj=fobj[1].H
! ! neigh=n:compare spectra with the reference window; y: compare spectral with the previous window
! ! ver=y:compare spectral along z; n: compare spectral along x
! ! ngroup=ng:sum ng points of spectra along x
! ! nref=1: compare spectra with the nref window
! ! nsmth=1: smooth slopsft along windows
! ! alpha=1.: correct slope to get dimg
! ! slop_neg=true: only consider the slope with negative value


!!! July 10, BP
!!! 1. Add opt=7 for image pertuabation: small window normalized by avg(spex2)
!!! 2. if (neigh): slop is the cumulative summation from nref; for horizontal comparison only

program dimg
  use sep
  use util_axisIO
  use line
  use smallsolver
  use cgstep_mod
  use wei_myfft_mod
  use wei_hamming_mod

  implicit none

 
  integer			:: n1, n2, n3, n4, n5
  real				:: d1, d2, d3, d4, d5, o1, o2, o3, o4, o5
  integer			:: i1, i2, i3, i4, i5, iwin, ig, is3, is5
  real				:: dw,ow
  integer			:: ismth, nsmth
  integer			:: nw, stat
  integer			:: tbeg, tend,tend2
  logical			:: neigh, ver, slop_neg
  integer			:: ng, nref, dimgopt
  integer			:: dwin, nwin, lwin, niter, nwin2
  real				:: fmin, fmax, alpha
  integer			:: nf, iif, ifmin
  type(myaxis)  		:: axis1,axis2,axis3,axis4,axis5,axis6,axis7,axis8
  complex, allocatable 		:: ctrace1(:),ctrace2(:),wtrace(:)
  complex, allocatable		:: fft1(:,:,:,:),fft2(:,:,:,:)
  real, allocatable		:: spex(:,:,:,:), spex2(:,:,:,:)
  real, allocatable		:: rati(:,:,:,:)
  real, allocatable		:: ftln(:,:,:,:)
  real, allocatable		:: slop(:,:,:),slopsft(:,:,:), slopsft2(:,:,:), scalsft(:,:,:), scalsft2(:,:,:), slop_tmp(:,:,:), scal_tmp(:,:,:)
  real, allocatable		:: scal(:,:,:)
  real, allocatable		:: d(:), m(:)
  real, allocatable 		:: data(:,:,:,:,:),img(:,:,:,:,:)
  real, allocatable		:: maxspex2(:,:,:)
  real, allocatable		:: fobj(:)
  real, dimension (1) 		::endSgn



  call sep_init()


	
  call from_history ('n1',n1)
  call from_history ("d1",d1)
  call from_history ("o1",o1)

  call from_history ('n2', n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2) 

  call from_history ('n3',n3)
  call from_history ("d3",d3)
  call from_history ("o3",o3)

  call from_history ('n4',n4)
  call from_history ("d4",d4)
  call from_history ("o4",o4)

  call from_history ('n5', n5)
  call from_history ("d5", d5)
  call from_history ("o5", o5) 

  ow=0.
  nw=n5;
  dw = 1./(n5*d5)
  call from_param("nwin",nwin,10)
  call from_param("lwin",lwin,n5/5)
  call from_param("fmin",fmin, ow)
  call from_param("fmax",fmax, (ow+(nw-1)*dw)/2.)
  call from_param("niter", niter,50)
  call from_param("neigh", neigh,.false.)
  call from_param("ver", ver,.true.)
  call from_param("ngroup", ng,1)
  call from_param("nref", nref,1)
  call from_param("nsmth", nsmth,1)
  call from_param("alpha", alpha,1.)
  call from_param("slop_neg", slop_neg,.true.)
  call from_param("dimgopt", dimgopt,1)
  if(nwin==1) then
	dwin=0
  else
	  dwin=(n5-lwin*nwin)/(nwin-1)
  end if
  write(0,*)'dwin',dwin+lwin
  nwin2=n5/(lwin+dwin)
  nf=(fmax-fmin)/dw+1   !!! pick nf for least square
  allocate(ctrace1(n5),ctrace2(n5), wtrace(nw),data(n1, n2, n3, n4, n5), img(n1, n2, n3, n4, n5),fft1(n3, n4, nwin, nw),fft2(n3, n4, nwin2, nw))
  allocate(spex(n3, n4, nwin, nw),spex2(n3,n4,nwin2,nw),rati(n3, n4, nwin, nw), ftln(n3, n4, nwin, nw))
  allocate(slop(n3, n4, nwin),scal(n3, n4, nwin),slopsft(n3,n4,n5),slopsft2(n3,n4,nwin),scalsft(n3,n4,n5), scalsft2(n3, n4, n5), slop_tmp(n3 ,n4, n5), scal_tmp(n3, n4, n5))
  allocate(m(2),d(nf))
  allocate(maxspex2(n3, n4, nwin2))
  allocate(fobj(1))
  call sep_read(data)

!!!!!!!!!!!!  FFT
!???????????  no hamming window, nz=nw
!!! for Q analysis
  fft1=0.;
  do i2=1, n2
  do i1=1, n1
  do i4=1,n4
    do i3=1,n3
      do iwin=1,nwin

        
	tbeg=(iwin-1)*(lwin+dwin)+1
	tend=tbeg+lwin-1    

	if(tend .gt. n5 ) then
	  tend=n5
        end if
        ctrace1=0.;
        ctrace1(tbeg:tend)=data(i1, i2 ,i3 , i4, tbeg:tend)
	call FFT1DX(ctrace1, 1)

        fft1(i3, i4, iwin, :) =ctrace1	

      end do

    end do
  end do
  end do 
  end do

!!! for inverse FFT to get dimg
  fft2=0.;

  do i2=1, n2
  do i1=1, n1
  do i4=1,n4
    do i3=1,n3
      do iwin=1,nwin2
      
	tbeg=(iwin-1)*(lwin+dwin)+1
	tend2=tbeg+lwin+dwin-1 
	if(tend2 .gt. n5 ) then
	  tend2=n5
        end if
	ctrace2=0.
        ctrace2(tbeg:tend2)=data(i1, i2 ,i3 , i4, tbeg:tend2)
	call FFT1DX(ctrace2, 1)
        fft2(i3, i4, iwin, :) =ctrace2	
      end do

    end do
  end do
  end do 
  end do
!!!!!!!!!!!! spectral : group the traces or not
 spex=0.0
  do i4=1,n4
  do i3=1,n3
     do ig=1,ng
	if (i3+ig-1 .gt. n3) then
		exit
	else
    		 spex(i3, i4, :, :)=spex(i3,i4,:,:)+abs(fft1(i3+ig-1, i4, :, :))
	end if
     end do
  end do
  end do

!!!!!!!!!!!! spectral : group the traces or not
 spex2=0.0
  do i4=1,n4
  do i3=1,n3
     do ig=1,ng
	if (i3+ig-1 .gt. n3) then
		exit
	else
    		 spex2(i3, i4, :, :)=spex2(i3,i4,:,:)+abs(fft2(i3+ig-1, i4, :, :))
	end if

     end do
  end do
  end do




write(0,*) "FFT..."
!!!!!!!!!!!! spectral ratio  (vertical vs horizontal; first vs neighbor )
!?????????? if (spex(i3,i4,iwin,i5) .lt. 1./1000.*rtmax) then rati(i3,i4,iwin,i5)=0.



  rati=0.
  do i4=1, n4
  do i2=1, n2
  do i1=1, n1
  ! vertial window compare
  if (ver) then  
    do i3=1, n3
    do i5=1, nw
      ! reference window compare, by default nref=1
      if (neigh == .false.) then
	if (spex(i3,i4,nref,i5)==0.) then
		rati(i3,i4,:,i5)=0.	
	else
		do iwin=1,nwin
			if (spex(i3,i4,iwin,i5)==0.) then
				rati(i3, i4, iwin, i5)=0.0
			else			
				rati(i3, i4, iwin, i5)=log(spex(i3,i4,iwin,i5)/spex(i3,i4,nref,i5))
			end if

 		end do
	end if
      ! neighbor window compare
      else
 	rati(i3,i4,1,i5)=1.
	do iwin=2,nwin
	   if (spex(i3,i4,iwin-1,i5)==0. .OR. spex(i3,i4,iwin,i5)==0.0 ) then
		rati(i3,i4,iwin,i5)=0.	
	   else
		rati(i3,i4,iwin,i5)=log(spex(i3,i4,iwin,i5)/spex(i3,i4,iwin-1,i5))
	   end if
	end do
      end if
    end do
    end do 
  ! horizontal window compare
  else   
    do iwin=1,nwin
    do i5=1, nw
      ! reference window compare, by default nref=1
     if (neigh == .false.) then
	         if (spex(nref, i4, iwin, i5) ==0.) then
		rati(:, i4, iwin, i5)=0.
         else
		do i3=1, n3
			if (spex(i3, i4, iwin, i5) ==0.) then
				rati(i3, i4, iwin, i5)=0.
			else		
				rati(i3, i4, iwin, i5) = log (spex(i3, i4, iwin, i5)/spex(nref, i4, iwin, i5))
			end if
		end do
	 end if
      ! neighbor window compare
     else
	rati(1,i4, iwin, i5) =1. 
	do i3=2, n3
	   if (spex(i3-1,i4,iwin,i5)==0. .or. spex(i3,i4,iwin,i5)==0.) then
		rati(i3,i4,iwin,i5)=0.	
	   else
		rati(i3,i4,iwin,i5)=log(spex(i3,i4,iwin,i5)/spex(i3-1,i4,iwin,i5))
	   end if
        end do
      end if
     end do
     end do
  end if
  end do
  end do
  end do
write(0,*) "Spectral ratio"

!!!!!!!!!!!!!!!!!! least square fitting

  d=0.; m=0.;
  slop=0.;scal=0.; ftln=0.


  do i2=1, n2
  do i1=1, n1
  do i4=1, n4
  if (ver) then
    do i3=1, n3
    slop(i3,i4,1)=0.
    scal(i3,i4,1)=0.
    ftln(i3,i4,1,:)=0.
     do iwin=2, nwin
        do iif=1,nf
	  ifmin=(fmin-ow)/dw
  	  d(iif)=rati(i3, i4, iwin, ifmin+iif)

        end do

	call line_init(nf, fmin, dw)
        stat = line_lop( .true., .false., m, d)
	call solver(oper=line_lop, solv=cgstep, x=m,dat=d,niter=niter)
	slop(i3,i4,iwin)=m(1)
 	scal(i3,i4,iwin)=m(2)
	do i5=1,nw/2
		ftln(i3,i4,iwin,i5)=scal(i3,i4,iwin)+slop(i3,i4,iwin)*((i5-1)*dw+ow)
	end do
	!write(0,*) "scal, slop", scal(i3,i4,iwin),slop(i3,i4,iwin)
    end do
    end do
  else
    do iwin=1, nwin
    slop(nref,i4,iwin)=0.
    scal(nref,i4,iwin)=0.
    ftln(nref,i4,iwin,:)=0.
     do i3=1, n3
        do iif=1,nf
	  ifmin=(fmin-ow)/dw
  	  d(iif)=rati(i3, i4, iwin, ifmin+iif)

        end do

	call line_init(nf, fmin, dw)
        stat = line_lop( .true., .false., m, d)
	call solver(oper=line_lop, solv=cgstep, x=m,dat=d,niter=niter)
	slop(i3,i4,iwin)=m(1)
 	scal(i3,i4,iwin)=m(2)
	do i5=1,nw/2
		ftln(i3,i4,iwin,i5)=scal(i3,i4,iwin)+slop(i3,i4,iwin)*((i5-1)*dw+ow)
	end do
	
	!write(0,*) "scal, slop", scal(i3,i4,iwin),slop(i3,i4,iwin)
    end do

   end do

  end if
  end do 
  end do
  end do

write(0,*) "least square"

 !!!!!!!!!!!!!!!!!!1 ! image pertubation
	! 1. shift and smooth and eclip=0.0
	slopsft=0.
	fobj=0.
	do i3=ng/2,n3
	do i4=1,n4
!	do iwin=1, nwin
	do i5=lwin/2,n5
		is3=i3-ng/2+1
! 		is5=iwin
! 		i5=iwin
		is5=(i5-lwin/2)/(lwin+dwin)+1
		do ismth=1,nsmth
			if (is5+ismth-1 .gt. nwin ) then
				exit
			else
				slopsft(i3,i4,i5)=slopsft(i3,i4,i5)+slop(is3,i4,is5+ismth-1)
				scalsft(i3,i4,i5)=scalsft(i3,i4,i5)+scal(is3,i4,is5+ismth-1)
			end if
		!write(0,*) "is3, is5, nwin", is3, is5, nwin
		end do
	
		if ((slopsft(i3, i4, i5) .gt. 0.) .and. (slop_neg .ne. .false.)) then

			slopsft(i3, i4, i5) =0.
			scalsft(i3, i4, i5) =0.
		else
			slopsft(i3,i4,i5)=slopsft(i3,i4,i5)/nsmth
			scalsft(i3,i4,i5)=scalsft(i3,i4,i5)/nsmth

		end if

		fobj=fobj+(slopsft(i3, i4, i5)*slopsft(i3, i4, i5))/n3/n4/n5
	end do
	end do
	end do
write(0,*) "slope shift"


	! 2 inverse FFT
  wtrace=0.
  img=0.
  do i2=1, n2
  do i1=1, n1
  do i4=1, n4
    do i3=1,n3

    !!! dimg: small windowed local FFT * correction; normalized by avg(spex)


    do iwin=1, nwin2
	is5=(iwin-1)*(lwin+dwin)+1
	maxspex2(i3 ,i4, iwin)=sum(spex2(i3, i4,iwin, :))/nw
	wtrace(1)=fft2(i3,i4,iwin,1)/exp(scalsft(i3, i4, is5))/maxspex2(i3, i4, iwin)*(slopsft(i3, i4, is5)*(ow))
       do i5=2,(nw/2)+1

    	    wtrace(i5) = (fft2(i3, i4, iwin, i5))/(maxspex2(i3, i4, iwin))  *(slopsft(i3, i4, is5)*(ow+dw*(i5-1)))
    	    wtrace(nw-i5+2) = (fft2(i3, i4, iwin, nw-i5+2))/(maxspex2(i3, i4, iwin))* (slopsft(i3, i4, is5)*(ow+dw*(i5-1)))
       end do
       call FFT1DX(wtrace, -1)
       img(i1, i2, i3, i4, :) = img(i1, i2, i3, i4, :)+ real(wtrace(:))
       wtrace = 0.

    end do


    end do
  end do
  end do 
  end do

write(0,*) "perturb image"

  call to_history ('n1',n1)
  call to_history ("d1",d1)
  call to_history ("o1",o1)

  call to_history ('n2', n2)
  call to_history ("d2", d2)
  call to_history ("o2", o2) 

  call to_history ('n3',n3)
  call to_history ("d3",d3)
  call to_history ("o3",o3)

  call to_history ('n4', n4)
  call to_history ("d4", d4)
  call to_history ("o4", o4) 

  call to_history ('n5', n5)
  call to_history ("d5", d5)
  call to_history ("o5", o5) 



  call set_axis(axis1,n3,d3,o3+(ng)*d3/2.,"mx")
  call set_axis(axis2,n4,d4,o4,"my")
  call set_axis(axis3,nwin,(lwin+dwin)*d5,o5+lwin/2.*d5,"win")
  call set_axis(axis4,nw,dw,ow,"freq")
  call set_axis(axis5,1,1.,0.," ")
  call set_axis(axis6,n3,d3,o3,"mx")
  call set_axis(axis7,n4,d4,o4,"my")
  call set_axis(axis8,n5,d5,o5,"z")


  call houtaxis(axis1,1,'spex')
  call houtaxis(axis2,2,'spex')
  call houtaxis(axis3,3,'spex')
  call houtaxis(axis4,4,'spex')
  call houtaxis(axis5,5,'spex')

  call houtaxis(axis1,1,'rati')
  call houtaxis(axis2,2,'rati')
  call houtaxis(axis3,3,'rati')
  call houtaxis(axis4,4,'rati')
  call houtaxis(axis5,5,'rati')

  call houtaxis(axis1,1,'ftln')
  call houtaxis(axis2,2,'ftln')
  call houtaxis(axis3,3,'ftln')
  call houtaxis(axis4,4,'ftln')
  call houtaxis(axis5,5,'ftln')

  call houtaxis(axis1,1,'slop')
  call houtaxis(axis2,2,'slop')
  call houtaxis(axis3,3,'slop')
  call houtaxis(axis5,4,'slop')
  call houtaxis(axis5,5,'slop')

  call houtaxis(axis6,1,'slopsft')
  call houtaxis(axis7,2,'slopsft')
  call houtaxis(axis8,3,'slopsft')
  call houtaxis(axis5,4,'slopsft')
  call houtaxis(axis5,5,'slopsft')

  call houtaxis(axis1,1,'scal')
  call houtaxis(axis2,2,'scal')
  call houtaxis(axis3,3,'scal')
  call houtaxis(axis4,4,'scal')
  call houtaxis(axis5,5,'scal')

  call houtaxis(axis5,1,'fobj')

  call sep_write(spex,'spex')
  call sep_write(rati, 'rati')
  call sep_write(ftln, 'ftln')
  call sep_write(slop, 'slop')
  call sep_write(slopsft, 'slopsft')
  call sep_write(scal, 'scal')
  call sep_write(fobj, 'fobj')
  call sep_write(img)
  call sep_write(endSgn,'end')
  deallocate(ctrace1,ctrace2, wtrace, data, fft1,fft2,img)
  deallocate(spex,spex2,rati)
  deallocate(ftln,slop,scal,m,d,slopsft, slopsft2, scalsft, slop_tmp, scal_tmp)
  deallocate(maxspex2)
  deallocate(fobj)
  call sep_close()
end program

