program main
  use bwi_dipcal_mod
  use bwi_dipflt_mod
  use base_ioutil_mod
  implicit none

  type(axis) :: ax, ay, az
  integer    :: rect1, rect2, rect3, nsmt, stat
  real, dimension(:,:,:), allocatable :: f, g, v, r

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  call from_param("rect1", rect1, 1)
  call from_param("rect2", rect2, 1)
  call from_param("rect3", rect3, 1)
  call from_param("nsmt" , nsmt , 1)

  call auxinout("f")
  call auxinout("g")
  call auxinout("dip")
  call auxinout("ref")

  call hinaxis("f", ax, 1)
  call hinaxis("f", ay, 2)
  call hinaxis("f", az, 3) 

  call houaxis("g", ax, 1)
  call houaxis("g", ay, 2)
  call houaxis("g", az, 3)

  call houaxis("dip", ax, 1)
  call houaxis("dip", ay, 2)
  call houaxis("dip", az, 3)

  allocate(f(ax%n,ay%n,az%n))
  allocate(g(ax%n,ay%n,az%n))
  allocate(v(ax%n,ay%n,az%n))
  allocate(r(ax%n,ay%n,az%n))
  call sep_read(f, "f")
  call sep_read(r, "ref")

  stat = bwi_dipcal_init(ax, ay, az, rect1, rect2, rect3, nsmt)

  stat = bwi_dipcal_oper(r, v)

  stat = bwi_dipcal_clos()
!  stat = bwi_dipflt_kill(.false., .false., f, g, v)
!  stat = bwi_dipflt_kill(.true. , .false., f, g, v)
!  g = f
 
  stat = bwi_dipflt_cscd(f, g, v, ax, ay, az)


  call sep_write(v, "dip")
  call sep_write(g, "g")


end program
