program main
  use sep
!  use helicon
!  use polydiv
!  use wilson
  use base_hlxtyp_mod
  use base_poldiv_mod
  use base_wilson_mod
use bwi_poldiv_mod
!  use lapfac
  implicit none

  type(helix) :: aa, lap

  integer :: n1, n2, na, stat, i
  real    :: o1, o2, d1, d2, a0, lap0, u1, u2, v1, v2, m, p, PI, dip
  real, dimension(:), allocatable :: xx, yy, zz
  real, dimension(:,:,:), allocatable :: x, y, z
  integer, dimension(:,:,:), allocatable :: selc

  PI = 3.14159265359

  call initpar()
  d1 = 10; d2 = 10
  o1 = 0.; o2 = 0.
  n1 = 201; n2 = 201
  na = 5

  allocate(xx(n1*n2), yy(n1*n2), zz(n1*n2))
  allocate(x(n1,1,n2),y(n1,1,n2),z(n1,1,n2))
  allocate(selc(n1,1,n2))

  xx(n1*n2/2) = 1.

  x(n1/2,1,n2/2) = 1.

!  x=0
!  x(n1/2,:)=1

!  xx=reshape(x,(/n1*n2/))
!call random_number(xx)

  call allocatehelix(lap, 4)

dip = -41
u1 =  cos(dip*PI/180.)
u2 = -sin(dip*PI/180.)
!u1 = cos(atan(0.84))
!u2 = -sin(atan(0.84))

!u1 =.9950042    
!u2 = -0.099833421

v1 = sin(dip*PI/180.)
v2 = cos(dip*PI/180.)
m = (u1-u2)*0.5
p = (u1+u2)*0.5

  lap0 = 1.+0.08
  lap%lag = (/1, n1-1, n1, n1+1/)
  lap%flt = (/2*m*p, -p*p, -2*m*p, -m*m/)

!lap0 = v1*v1+v2*v2+(v1+v2)**2
!lap%lag = (/1,n1-1,n1,n1+1/)
!lap%flt = (/-v1*(v1+v2),v1*v2,-v2*(v1+v2),0./)

!lap0 = lap0*10
!lap%flt = lap%flt*10

!lap0 = 1.5
!lap%lag = (/1, n1-1, n1, n1+1/)
!lap%flt = (/0.25, -0.5, -0.5, 0./)

write(0,*)lap%flt, lap0, '--', u1, u2, 'm,p', m, p

  call allocatehelix(aa, 3*na)
  aa%flt = 0.
  do i=1, na
     aa%lag(i)      = i
     aa%lag(na+i)   = n1+i-na
     aa%lag(2*na+i) = n1+i
  end do

!  call wilson_init(10*n1)
!  call wilson_factor(100, lap0, lap, a0, aa)
!  call wilson_close() 


stat = base_wilson_init(maxval(lap%lag)+1)
stat = base_wilson_oper(20, lap0, lap, a0, aa)
stat = base_wilson_clos()

write(0,*)"ddddddddd"

  call deallocatehelix(lap)
!  aa = lapfac2(0., n1, na) 
write(0,*)aa%flt
write(0,*)a0

  stat = base_poldiv_init(aa, a0, n1*n2)
  stat = base_poldiv_oper(.false.,.false.,xx,zz)
  stat = base_poldiv_oper(.true. ,.false.,yy,zz)
  stat = base_poldiv_clos()

!stat = bwi_poldiv_init(aa, a0, n1, 1, n2)
!stat = bwi_poldiv_oper(.false.,.false.,x,z)
!stat = bwi_poldiv_oper(.true.,.false.,y,z)

!call polydiv_init(n1*n2,aa)
!stat = polydiv_lop(.false.,.false.,xx,zz)
!stat = polydiv_lop(.true.,.false.,yy,zz)

  call to_history("n1", n1); call to_history("o1", o1); call to_history("d1", d1)
  call to_history("n2", n2); call to_history("o2", o2); call to_history("d2", d2)

  call sep_write(yy)

end program
