program fpeak
  use sep
  use util_axisIO

  implicit none

 
  integer ::n2,i2,i1,n1,n3
  real,  allocatable :: spectra(:,:),fpeak2(:,:),fpeak1(:)
  real::d1,d2,d3,o2
  real::top,bot,loc_real
  integer::loc
  type(myaxis)   ::axis_dummy,axis_n2


  write(0,*) "fpeak.x < input.H fpeak_loc=fpeak_loc.H > output.H"

  call sep_init()

  call from_history ('n1',n1)
  call from_history ("d1",d1)
  call from_history ('n2', n2,1)
  call from_history ('d2',d2)
  call from_history ('o2',o2)
  call from_history ('n3', n3,1)
  call from_history ('d3',d3,1.0)

  allocate(spectra(n1,n2),fpeak2(n1,n2),fpeak1(n2))
  call sep_read(spectra)

  fpeak1=0
  do i2=1,n2
	top=0
	bot=0
	do i1=1,n1
		top=top+i1*d1*spectra(i1,i2)
		bot=bot+spectra(i1,i2)

	end do
	loc=top/bot
	loc_real=top/bot
!	write(0,*) "loc", loc
		fpeak2(loc,i2)=spectra(loc,i2)
		fpeak1(i2)=loc_real

  end do

  call to_history('n1',n1)
  call to_history('n2',n2)

  call to_history('d1',d1)
  call to_history('d2',d2)
  
  call set_axis(axis_dummy,1,1.0,1.0,"")
  call houtaxis(axis_dummy,2,'fpeak_loc')
  call set_axis(axis_n2,n2,d2,o2,"")
  call houtaxis(axis_n2,1,'fpeak_loc')

  call sep_write(fpeak2)
  call sep_write(fpeak1,'fpeak_loc')

  deallocate(fpeak2,spectra,fpeak1)

  call sep_close()
end program

