module line
  ! simple Q transform

  use adj_mod

  implicit none
  integer, private :: nk, ik
  real   , private :: kmin, k, d1

  contains

  subroutine line_init ( nk_in, kmin_in, d1_in)
    real    :: kmin_in, d1_in
    integer :: nk_in


    nk=nk_in
    kmin=kmin_in
    d1=d1_in


  end subroutine

  function line_lop( adj, add, m, d) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: m,d
    call adjnull      (adj,add,m,d )
    call line_lop2(adj,add,m,d )
    stat=0
  end function 

  subroutine line_lop2(adj,add,m,d)
    logical,intent(in) :: adj,add 
    real, dimension (2)  :: m
    real, dimension (nk)  :: d
    integer		     :: ik
    real		     :: k

    do ik=1,nk
    	k=kmin+d1*(ik-1)
	if (adj) then
		m(1)=m(1)+k*d(ik)
		m(2)=m(2)+d(ik)

	else
		d(ik)=d(ik)+m(1)*k+m(2)
	end if
   end do

  end subroutine
 
  subroutine line_close()
  end subroutine

end module
! end module
