program mute
  use sep

  implicit none

 
  integer :: n1,n2,n3,i1,i2,i3,rfl
  real, dimension(:,:,:), allocatable :: d,d_mute
  real::d1,d2,d3
  real::v0,z0,t_thr,src_ox
  real::l0,l_thr,l,ishot,t,x,z

  write(0,*) "mute.x < data.H v0=[] z0=[] t_thr=[] src_ox=[] rfl=0 > output.H"

  call sep_init()


  call from_history ('n1',n1)
  call from_history ("d1",d1)
  call from_history ('n2', n2,1)
  call from_history ('d2',d2)
  call from_history ('n3', n3,1)
  call from_history( 'd3',d3,1.)

  call from_param ("v0", v0, 3000.)
  call from_param ("z0", z0, 900.)
  call from_param ("t_thr", t_thr, 0.1)
  call from_param ("src_ox", src_ox,0. )
  call from_param ("rfl",rfl,0)

  allocate(d(n1,n2,n3),d_mute(n1,n2,n3))
  call sep_read(d)

  d_mute=d

  write(0,*) "input,v0,z0,t_thr,src_ox ",sum(d)/n1/n2/n3,v0,z0,t_thr,src_ox 
  do i1=1,n1
     t=i1*d1
     l0=(v0*t/2)**2
     l_thr=(v0*t_thr/2)**2  
     l=l0+l_thr
    do i2=1,n2
       z=z0**2
      do i3=1,n3
         ishot=(i3-1)*d3+src_ox
         x=((i2-ishot)*d2/2)**2 
	if (rfl .eq. 0) then
	         if (l .lt. (x+z)) then
		 	d_mute(i1,i2,i3)=0.
		 endif
	else if(rfl .eq.1) then
		if (l .gt.(x+z)) then
			d_mute(i1,i2,i3)=0.
		endif
        end if
      end do
    end do
  end do




  call to_history('n1',n1)
  call to_history('n2',n2)
  call to_history('n3',n3)
  call to_history('d1',d1)
  call to_history('d2',d2)
  call to_history('d3',d3)

  call sep_write(d_mute)

  deallocate(d,d_mute)

  call sep_close()
end program

