! myMPI-srchdrct.f90 srch=srch.H(output) grdo=grdo.H(input) grdp=grdp.H(optional) method="sdstep" rstart=n
program main
  use bwi_search_mod
  implicit none


  type(vel_grid)     :: vgrid
  type(q_grid)       :: qgrid
  character(len=6)   :: method
  logical            :: rstart
  integer            :: stat
  character(len=256) :: srch_, grdo_, grdp_

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  srch_ = "srch"
  grdo_ = "grdo"
  grdp_ = "grdp"

  call from_param("method", method, "sdstep")
  call from_param("rstart", rstart, .false. )

  call auxinout(srch_)
  call auxinout(grdo_)

  call hinaxis(grdo_, qgrid%ax, 1)
  call hinaxis(grdo_, qgrid%ay, 2)
  call hinaxis(grdo_, qgrid%az, 3)

  if (method=="cgstep") then
!     write(0,*)"METHOD = CGSTEP"
     call auxinout(grdp_)
  else
     call houaxis(srch_, qgrid%ax, 1)
     call houaxis(srch_, qgrid%ay, 2)
     call houaxis(srch_, qgrid%az, 3)

  end if

  select case (method)
    case ("sdstep")
         stat = bwi_sdstep_oper(srch_, grdo_, qgrid)
    case ("cgstep")
         stat = bwi_cgstep_oper(srch_, grdo_, grdp_, qgrid, rstart)
  end select

  call sep_end_prog()

  call exit()

end program
