!!! grdp=grdo+isrch*alpha*srch (the searched gradient with search direction and length)
!!! <grdo.H(Previous Q model) myMPI-srchprcs.f90 srch=srch.H alpha=alpha.H isrch=[1] qmax=[5.0] qmin=[2.3]>grdp.H(updated Q model)
program main
  use sep
  implicit none

  integer:: n1, n2, n3, i1, i2, i3
  real, allocatable:: srch(:,:,:), grdp(:,:,:), grdo(:,:,:), alpha(:)
  integer:: isrch
  double precision::  norm
  real:: qmax, qmin

  call sep_init()

  call from_history("n1", n1)
  call from_history("n2", n2)
  call from_history("n3", n3)

  allocate(srch(n1 ,n2, n3), grdp(n1, n2, n3), alpha(1), grdo(n1, n2, n3))

  call sep_read(srch, "srch")
  call sep_read( alpha, "alpha")
  call sep_read(grdo)
  call from_param("isrch", isrch, 1)
  call from_param('qmax', qmax, 5.0)
  call from_param('qmin', qmin, 2.3)


!!! Normalize
  norm = maxval(abs(srch))
  srch = srch/norm

   do i1=1, n1
     do i2=1, n2
       do i3=1, n3
         grdp(i1, i2, i3)=grdo(i1, i2, i3)+isrch*alpha(1)*srch(i1, i2, i3)
	 if (grdp(i1, i2, i3) .gt.qmax) then
		grdp(i1, i2, i3)=qmax
	  else if (grdp(i1, i2, i3) .lt. qmin) then
		grdp(i1, i2, i3)=qmin
	 end if
       end do 
     end do
   end do
  call sep_write(grdp)
  deallocate(srch, grdp, alpha, grdo)
  call sep_close()

end program
