!!! search for alph: <grdo.H(Previous Q model) nsrch=[3] alphP=alphP.H alphO=alphO.H fobjP=fobjP.H(current) fobjO=fobjO.H(previous) fobj=fobj.H(output) srch=srch.H >grdp.H(Updated Q model)
program main
  use sep
  use util_axisIO
  implicit none


    integer			  :: nsrc
    integer			  :: n1, n2, n3, i1, i2, i3
    real 			  :: sfac, norm
    real, allocatable		  :: fp(:), fo(:),  fobj(:)
    real, allocatable		  :: alphP(:),alphO(:), grdo(:,:,:), grdp(:,:,:), srch(:,:,:)
    real	                  :: fopt
    integer			  :: iopt, isrc
    real			  :: qmin, qmax
    type(myaxis)  		  :: axis1
 
    call sep_init()

    call from_param("nsrch", nsrc, 3)
    call from_param('qmax', qmax, 5.0)
    call from_param('qmin', qmin, 2.3)
    call from_history("n1", n1)
    call from_history("n2", n2)
    call from_history("n3", n3)

    allocate(fp(nsrc), fo(1), alphP(1),alphO(1), grdo(n1, n2, n3), grdp(n1, n2, n3), srch(n1, n2, n3), fobj(1) )

    call sep_read(fp, "fobjP")
    call sep_read(fo, "fobjO")
    call sep_read(alphO, "alphO")
    call sep_read(srch, "srch")
    call sep_read(grdo)

    sfac = 0.5*(nsrc+1)
    norm = maxval(abs(srch))
    srch = srch/norm
!   find the minimum one over fp(isrc)
!   --------------------
    fopt = fp(1)
    iopt = 1
    do isrc=1, nsrc
       if (fp(isrc)<=fopt) then
          iopt = isrc
          fopt = fp(isrc)
	write(0,*) "iopt, fopt", iopt, fopt
       end if
    end do
!   compare with the current objective function value
    write(0,*) "fo, fp", fo(1), fp(iopt)
   !!! Current obj is the minimum
   if (fp(iopt)<=1.2*fo(1)) then

      grdp = grdo + alphO(1)*iopt*srch
      alphP(1) = alphO(1)*iopt/sfac
      fobj(1) = fp(iopt)
	write(0,*) "current one is the minimum. grdp", minval(grdp)
   !!! Previous obj is  the minimum
   else
      fobj(1)=fo(1)
      grdp = grdo
      alphP(1) = alphO(1) * 0.5 
	write(0,*) "previouse one is the minimum. grdp", minval(grdp)
   end if
    write(0,*) "fobj", fobj
   !!! hard boundary for q value
     do i1=1, n1
     do i2=1, n2
       do i3=1, n3
	 if (grdp(i1, i2, i3) .gt.qmax) then
		grdp(i1, i2, i3)=qmax
	  else if (grdp(i1, i2, i3) .lt. qmin) then
		grdp(i1, i2, i3)=qmin
	 end if
       end do 
     end do
   end do
   !!! output: grdp, alph, fobj 

  call set_axis(axis1,1,1.0,0.0," ")
  call houtaxis(axis1,1,'fobj')
  call houtaxis(axis1,1,'alphP' )

  call sep_write(fobj,'fobj')
  call sep_write(alphP, 'alphP')
  call sep_write(grdp)

  deallocate(fp, fo, alphP,alphO, grdo, grdp, srch, fobj )

  call sep_close()

end program
