program main
  use base_struct_mod
  use base_ioutil_mod
  use off2ang_kernsd_mod
  use off2ang_kernfd_mod
  use off2ang_fileio_mod
  implicit none


  real   , dimension(:,:,:), allocatable :: rgtho, rgtha
  complex, dimension(:,:,:), allocatable :: cgtho, cgtha
  type(axis)                             :: ax, ay, az
  type(axis)                             :: ahx, ahy
  type(axis)                             :: aagl_rfl, aagl_azm
  type(off2ang)                          :: po2a

  character(len=256)                     :: gtho_, gtha_

  integer                                :: ix, iy, stat, esize
  real                                   :: agl_rfl_min, agl_rfl_max

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  gtho_ = "gtho"
  gtha_ = "gtha"

  call from_param("ntphx" , po2a%ntphx , 3      )
  call from_param("ntphy" , po2a%ntphy , 1      )
  call from_param("ntpmz" , po2a%ntpmz , 5      )
  call from_param("eps"   , po2a%eps   , 100.   )
  call from_param("push"  , po2a%push  , .false.)
  call from_param("invt"  , po2a%invt  , .true. )
  call from_param("intp"  , po2a%intp  , 2      )
  call from_param("o2atyp", po2a%o2atyp, "space")

  call from_param("ntphx" , po2a%ntphx , 1      )
  call from_param("ntphy" , po2a%ntphy , 1      )
  call from_param("ntpmz" , po2a%ntpmz , 1      )

  call from_param("nhxpad", po2a%nhxpad, 0      )
  call from_param("nhypad", po2a%nhypad, 0      )
  call from_param("nmzpad", po2a%nmzpad, 0      )

  call auxinout(gtho_)
  call auxinout(gtha_)

  call hinaxis(gtho_, ahx, 1)
  call hinaxis(gtho_, ahy, 2)
  call hinaxis(gtho_, az , 3)
  call hinaxis(gtho_, ax , 4)
  call hinaxis(gtho_, ay , 5)
  call from_aux(gtho_, "esize", esize)


  call from_param("agl_rfl_min", agl_rfl_min, -50.)
  call from_param("agl_rfl_max", agl_rfl_max,  50.)

  call from_param("oagl_azm", aagl_azm%o, 0.)
  call from_param("dagl_azm", aagl_azm%d, 1.)
  call from_param("nagl_azm", aagl_azm%n, ahy%n)

  aagl_rfl%n = ahx%n
  aagl_rfl%o = agl_rfl_min
  if (aagl_rfl%n==1) then
     aagl_rfl%d = 1.
  else
     aagl_rfl%d = (agl_rfl_max-agl_rfl_min)/(aagl_rfl%n-1)
  end if


  call houaxis(gtha_, aagl_rfl, 1)
  call houaxis(gtha_, aagl_azm, 2)
  call houaxis(gtha_, az      , 3)
  call houaxis(gtha_, ax      , 4)
  call houaxis(gtha_, ay      , 5)
  call auxputch("esize", "i", esize, gtha_)
write(0,*)ahx, ahy, ax, ay, az
write(0,*)aagl_rfl, aagl_azm

  if (esize==4) then
     allocate(rgtho(ahx%n,ahy%n,az%n))
     allocate(rgtha(aagl_rfl%n,aagl_azm%n,az%n))
  else
     allocate(cgtho(ahx%n,ahy%n,az%n))
     allocate(cgtha(aagl_rfl%n,aagl_azm%n,az%n))
  end if

  select case (po2a%o2atyp)
    case ("space")
         stat = off2ang_kernsd_init(ahx,ahy,aagl_rfl,aagl_azm,az)
    case ("fouri")
         stat = off2ang_kernfd_init(ahx,ahy,aagl_rfl,aagl_azm,az,po2a)
  end select

  if (esize==4) then

     do iy=1, ay%n
     do ix=1, ax%n
        call off2ang_fio_gtho(rgtho,ax%n,ay%n,az%n,ahx%n,ahy%n,ix,iy,gtho_,"reed")
        rgtha = 0.
        select case (po2a%o2atyp)
          case ("space")
               stat = off2ang_kernsd_oper(rgtha, rgtho)
          case ("fouri")
               stat = off2ang_kernfd_oper(rgtha, rgtho)
        end select
        call off2ang_fio_gtha(rgtha,ax%n,ay%n,az%n,aagl_rfl%n,aagl_azm%n,ix,iy,gtha_,"rite")
     end do
     end do

  else

     do iy=1, ay%n
     do ix=1, ax%n
        call off2ang_fio_gtho(cgtho,ax%n,ay%n,az%n,ahx%n,ahy%n,ix,iy,gtho_,"reed")
        cgtha = 0.
        select case (po2a%o2atyp)
          case ("space")
               stat = off2ang_kernsd_oper(cgtha, cgtho)
          case ("fouri")
               stat = off2ang_kernfd_oper(cgtha, cgtho)
        end select
        call off2ang_fio_gtha(cgtha,ax%n,ay%n,az%n,aagl_rfl%n,aagl_azm%n,ix,iy,gtha_,"rite")
     end do
     end do

  end if
end program
