module off2ang_tapers_mod
  use  base_struct_mod
  use  base_window_mod
  real, dimension(:), pointer, private :: tphx, tphy, tpmz
  integer                    , private :: nhx, nhy, nmz
  integer                    , private :: ntphx, ntphy, ntpmz
contains

  integer function off2ang_tapers_init(tphx_in,tphy_in,tpmz_in,nhx_in,nhy_in,nmz_in,&
                                       ntphx_in,ntphy_in,ntpmz_in) result(stat)
    real, dimension(:), target :: tphx_in, tphy_in, tpmz_in
    integer                    :: nhx_in, nhy_in, nmz_in
    integer                    :: ntphx_in, ntphy_in, ntpmz_in

    tphx => tphx_in; nhx = nhx_in; ntphx = ntphx_in
    tphy => tphy_in; nhy = nhy_in; ntphy = ntphy_in
    tpmz => tpmz_in; nmz = nmz_in; ntpmz = ntpmz_in

    call hammiwin1d(tphx, ntphx)
    call hammiwin1d(tphy, ntphy)
    call hammiwin1d(tpmz, ntpmz)

    stat = 0
  end function

  integer function off2ang_tapers_oper(vec3d) result(stat)
    complex, dimension(:,:,:) :: vec3d
    integer                   :: ihx, ihy, imz
!   adding taper in hx
!   ------------------
    do imz=1, nmz
    do ihy=1, nhy
       vec3d(1:ntphx,ihy,imz)         = vec3d(1:ntphx,ihy,imz)        *tphx(1:ntphx:+1)
       vec3d(nhx-ntphx+1:nhx,ihy,imz) = vec3d(nhx-ntphx+1:nhx,ihy,imz)*tphx(ntphx:1:-1)
    end do
    end do
!   adding taper in hy
!   ------------------
    do imz=1, nmz
    do ihx=1, nhx
       vec3d(ihx,1:ntphy,imz)         = vec3d(ihx,1:ntphy,imz)        *tphy(1:ntphy:+1)
       vec3d(ihx,nhy-ntphy+1:nhy,imz) = vec3d(ihx,nhy-ntphy+1:nhy,imz)*tphy(ntphy:1:-1)
    end do
    end do
!   adding taper in mz
!   ------------------
    do ihy=1, nhy
    do ihx=1, nhx
       vec3d(ihx,ihy,1:ntpmz)         = vec3d(ihx,ihy,1:ntpmz)        *tpmz(1:ntpmz:+1)
       vec3d(ihx,ihy,nmz-ntpmz+1:nmz) = vec3d(ihx,ihy,nmz-ntpmz+1:nmz)*tpmz(ntpmz:1:-1)
    end do
    end do
    stat = 0
  end function

end module
