program main
  use base_ioutil_mod
  use bwi_restom_mod
  implicit none

  type(img_grid)     :: igrid
  type(hes_grid)     :: hgrid 

  double precision   :: fobj(1)
  real               :: hcut
  integer            :: dsotyp
  logical            :: dsorms
  character(len=6)   :: objtyp
  real               :: objeps
  logical            :: grdfix
  integer            :: stat

  character(len=256) :: bimg_, fobj_, imsk_, hess_

  bimg_ = "bimg"
  fobj_ = "fobj"
  imsk_ = "imsk"
  hess_ = "hess"

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  call from_param("hcut"  , hcut        , 0.      )
  call from_param("dsotyp", dsotyp      , 1       )
  call from_param("dsorms", dsorms      , .false. )
  call from_param("objtyp", objtyp      , "imgpow")
  call from_param("objeps", objeps      , 1.      )
  call from_param("grdfix", grdfix      , .false. )

  call from_param("stkimg", igrid%stkimg, .true.  )
  call from_param("imgmsk", igrid%imgmsk, .false. )
  call from_param("wnthes", hgrid%wnthes, .false. )

  call auxinout(bimg_)
  call auxinout(fobj_)

  if (igrid%imgmsk) call auxinout(imsk_)
  if (hgrid%wnthes) call auxinout(hess_)

  call hinaxis(bimg_, igrid%ahx, 1)
  call hinaxis(bimg_, igrid%ahy, 2)
  call hinaxis(bimg_, igrid%ax , 3)
  call hinaxis(bimg_, igrid%ay , 4)
  call hinaxis(bimg_, igrid%az , 5)

  if (.not.igrid%stkimg) then
     call hinaxis(bimg_, igrid%asx, 6)
     call hinaxis(bimg_, igrid%asy, 7)  
  end if

  call to_history("o1", 0., fobj_)
  call to_history("d1", 1., fobj_)
  call to_history("n1", 1 , fobj_)

  stat = bwi_restom_oper(bimg_, hess_, imsk_, igrid, hgrid, fobj(1), hcut, dsotyp, dsorms, objtyp, objeps, grdfix) 

  call sseek(fobj_, 0, 0)
  call sep_write(real(fobj), fobj_)

  call sep_end_prog()
 
  call exit()

end program
