!!! [2D flat reflector] spectral ratio-- Yi Shen, Apr 10, 2012
!!! The data should be in the following order: spectral, angle, ...
!!! spectral_ratio.x <input.H nref=[] output
!!! nref=[]: the reference trace

program spectral_ratio
  use sep
  use util_axisIO

  implicit none

 
  integer 			:: n1, n2, i1, i2
  real				:: d1, o1, d2, o2, mymax
  integer			:: nref
  real, allocatable		:: in(:,:), out(:,:)


  call sep_init()

  call from_history ('n1',n1)
  call from_history ("d1",d1)
  call from_history ("o1",o1)

  call from_history ('n2', n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2) 
	 
  call from_param("nref",nref)

  allocate(in(n1,n2), out(n1,n2))
  call sep_read(in)	
  
mymax=maxval(in)
do i1=1,n1
	if (in(i1,nref)==0.) then
		out(i1,:)=0.	
	else
		do i2=1,n2
			if (in(i1,i2) .lt. 1./1000.*mymax) then
				out(i1,i2)=0.
			else
				out(i1,i2)=log(in(i1,i2)/in(i1,nref))
			end if
 		end do
	end if
  end do



  call to_history ('n1',n1)
  call to_history ("d1",d1)
  call to_history ("o1",o1)

  call to_history ('n2', n2)
  call to_history ("d2", d2)
  call to_history ("o2", o2) 


  call sep_write(out)
  deallocate(out,in)	
  call sep_close()
end program

